---
title: String.prototype.trimStart()
slug: Web/JavaScript/Reference/Global_Objects/String/trimStart
tags:
  - JavaScript
  - Method
  - Prototype
  - Reference
  - String
---
<div>{{JSRef}}</div>

<p>The <strong><code>trimStart()</code></strong> method removes whitespace from the beginning of a string. <code>trimLeft()</code> is an alias of this method.</p>

<div>{{EmbedInteractiveExample("pages/js/string-trimstart.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>str</var>.trimStart();
<var>str</var>.trimLeft();</pre>

<h3 id="Return_value">Return value</h3>

<p>A new string representing the calling string stripped of whitespace from its beginning (left end).</p>

<h2 id="Description">Description</h2>

<p>The <code>trimStart()</code> / <code>trimLeft()</code> methods return the string stripped of whitespace from its left end. <code>trimLeft()</code> or <code>trimStart()</code> do not affect the value of the string itself.</p>

<h3 id="Aliasing">Aliasing</h3>

<p>For consistency with functions like {{jsxref("String.prototype.padStart")}} the standard method name is <code>trimStart</code>. However, for web compatibility reasons, <code>trimLeft</code> remains as an alias to <code>trimStart</code>. In some engines this means:</p>

<pre class="brush: js notranslate">String.prototype.trimLeft.name === "trimStart";</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Using_trimStart">Using trimStart()</h3>

<p>The following example displays the lowercase string <code>'foo  '</code>:</p>

<pre class="brush: js; highlight: [5] notranslate">var str = '   foo  ';

console.log(str.length); // 8

str = str.trimStart();
console.log(str.length); // 5
console.log(str);        // 'foo  '
</pre>

<h2 id="Polyfill">Polyfill</h2>

<pre class="brush: js; highlight: [5] notranslate">//https://github.com/FabioVergani/js-Polyfill_String-trimStart

(function(w){
    var String=w.String, Proto=String.prototype;

    (function(o,p){
        if(p in o?o[p]?false:true:true){
            var r=/^\s+/;
            o[p]=o.trimLeft||function(){
                return this.replace(r,'')
            }
        }
    })(Proto,'trimStart');

})(window);

/*
ES6:
(w=&gt;{
    const String=w.String, Proto=String.prototype;

    ((o,p)=&gt;{
        if(p in o?o[p]?false:true:true){
            const r=/^\s+/;
            o[p]=o.trimLeft||function(){
                return this.replace(r,'')
            }
        }
    })(Proto,'trimStart');

})(window);
*/</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-string.prototype.trimstart', ' String.prototype.trimStart')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.String.trimStart")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("String.prototype.trim()")}}</li>
 <li>{{jsxref("String.prototype.trimEnd()")}}</li>
</ul>
